
import { FormBuilder, Validators } from '@angular/forms';
import { CustomValidators } from 'ng2-validation';
import { BsModalService } from "ngx-bootstrap/modal";

import * as _ from 'lodash';
import { FlexTableComponent } from '../../../../shared/common/FlexTable.component';
import { OnInit, Component } from '@angular/core';

import { FrameRequest } from '../../../../shared/frame/frame-request';
import { AppComponent } from '../../../..';

//审批状态
const APPLY_STATUS = {
    NEW: 0,//草稿
    LOCAL_VERIFY: 1,//待现场验证
    PROV_VERIFY:2,//待省级验证
    ARCHIVE:3,//归档
    REFUSE:4
};

@Component({
    selector: 'cert_edu_apply_prov',
    templateUrl: './cert_edu_apply.component.prov.html',
    styleUrls: ['./cert_edu_apply.component.prov.scss']
})
export class CertEduApplyComponentProv extends FlexTableComponent implements OnInit {

    public query = {
        "ticket_no": "",
        "std_name": "",
        "std_cert_no": "",
        "cert_type_id": "",
        "time_config_id": "",
        "isdo": "",
        "is_atg":"",
        "status": "",
        "org_id":""
    };

    QUERY_URL = "mk/mkCertEduApply/page.htm";
    DELETE_URL = "mk/mkCertEduApply/delete.htm";
    GET_URL = "mk/mkCertEduApply/get.htm";
    ADD_URL = "mk/mkCertEduApply/add.htm";
    EDIT_URL = "mk/mkCertEduApply/edit.htm";
    GO_VERIFT_URL = "mk/mkCertEduApply/goVerify.htm";

    APPLY_VERIFY_URL = "mk/mkCertEduApply/verify.htm";
    APPLY_BATCH_VERIFY_URL = "mk/mkCertEduApply/batchVerify.htm";
    CERT_TYPE_List_URL= "mk/mkCertType/listAll.htm";
    VERIFY_ALL_URL= "mk/mkCertEduApply/verifyAll.htm";

    bsModalWin_verify : any;
    certTypeList = [];
    orgList = [];
    status:any;

    bsModalWin2 = null;
    file_path = null;
    curr_id = null;
    current = 0;

    constructor(
        public bsModalService: BsModalService,
        fb: FormBuilder
    ) {
        super();

        FrameRequest.requestArray(this.CERT_TYPE_List_URL, {type: 1}, (array) => {
            this.certTypeList = array;
          });

          FrameRequest.requestArray('cf/cfOrganization/list.htm', {org_type: [1,4], status: 1}, (array) => {
            this.orgList = array;
          });      
    
    }

    search(param) {
        if(!this.query.time_config_id){
            this.query.time_config_id = "";
        }
        if(!this.query.org_id){
            this.query.org_id = "";
        }

        let searchCondition = this.query;
        //参数合并
        _.assignIn(param, searchCondition);
    }

     //导出
  export() {
    AppComponent.GobalComponent.setLoading(true);
    FrameRequest.download("mk/mkCertEduApply/export.htm", {
        ticket_no : this.query.ticket_no,
        std_name : this.query.std_name,
        std_cert_no : this.query.std_cert_no,
        cert_type_id : this.query.cert_type_id,
        time_config_id: this.query.time_config_id,
        isdo: this.query.isdo,
        is_atg:this.query.is_atg,
        status: this.query.status,
        org_id: this.query.org_id
    }, () => {
      AppComponent.GobalComponent.setLoading(false);
      AppComponent.GobalComponent.successMsg("导出成功");
    });
  }

    goVerify(tpl,item){
       
        FrameRequest.requestEntity(this.GO_VERIFT_URL, {id: item.id}, (entity) => {
            this.item = entity;
            if(this.item.status !="2" && this.item.status !="3" && this.item.status !="4"){
                AppComponent.alert({title:"信息提示",text:"该状态无法审批"});
                return;
            }

            if(this.item.status =="2"){
                this.item.verify2_remark = '同意';
            }

            this.status = this.item.status;
            this.item.status = "1";
            this.editShowType = 'only';
            
            
            // this.shouModalWin_verify(tpl);
            
         });
    }

    goBatchVerify(tpl){
        let checkedArray =  this.framePager.getCheckedArray();
        if(checkedArray.length == 0){
            AppComponent.alert({title:"信息提示",text:"请选择数据!"});
            return;
        }
       
        this.item = {};
        this.item.verify2_remark = '同意';

        this.status = "2";
        this.item.status = "1";
        this.editShowType = 'only_batch';
        
    }

    async shouModalWin_verify(editFormTemplateModal, modalcss?) {
        if(!this.item) this.item = {};
        let css = modalcss ? modalcss : "modal-lg";//big_modal modal-lg
        this.bsModalWin= this.bsModalService.show(editFormTemplateModal, { class: css });
    }
    

    //现场审批
    async saveVerify(){

        if(!(this.item.status+"")){
            AppComponent.alert({title:"信息提示",text:"请填写审批状态!"});
            return
        }
        if(!this.item.verify2_remark || this.item.verify2_remark.lengh == 0){
            AppComponent.alert({title:"信息提示",text:"请填写审批意见!"});
            return
        }
        let verfiyStatus;
        switch (this.item.status) {
            case "0":
                verfiyStatus = APPLY_STATUS.REFUSE
                break;
            case "1":
                verfiyStatus = APPLY_STATUS.ARCHIVE
                break;
            default:
                break;
        }

        AppComponent.confirm("确定提交吗?",()=>{
            FrameRequest.requestMap(this.APPLY_VERIFY_URL, 
                { apply_id: this.item.id, status: verfiyStatus,verify2_remark:this.item.verify2_remark}, async(ret) => {
                    
                    this.hideModal();
                    //AppComponent.alert({title:"信息提示",text:"审批提交成功!"});
                    AppComponent.GobalComponent.successMsg("审批提交成功!");
                    this.framePager.reload();
                      
                   
             });
        });

        
    }

     //现场审批
     async saveBatchVerify(){
        let checkedArray =  this.framePager.getCheckedArray();
        if(checkedArray.length == 0){
            AppComponent.alert({title:"信息提示",text:"请选择申请单!"});
            return;
        }

        if(!(this.item.status+"")){
            AppComponent.alert({title:"信息提示",text:"请填写审批状态!"});
            return
        }
        if(!this.item.verify2_remark || this.item.verify2_remark.lengh == 0){
            AppComponent.alert({title:"信息提示",text:"请填写审批意见!"});
            return
        }
        let verfiyStatus;
        switch (this.item.status) {
            case "0":
                verfiyStatus = APPLY_STATUS.REFUSE
                break;
            case "1":
                verfiyStatus = APPLY_STATUS.ARCHIVE
                break;
            default:
                break;
        }

        let checkIds = this.framePager.getCheckedArray((item) => item.id);

        AppComponent.confirm("确定批量提交吗?",()=>{
            FrameRequest.requestMap(this.APPLY_BATCH_VERIFY_URL, 
                { ids: checkIds.join(), status: verfiyStatus,verify2_remark:this.item.verify2_remark}, async(ret) => {
                    
                    this.hideModal();
                    //AppComponent.alert({title:"信息提示",text:"审批提交成功!"});
                    AppComponent.GobalComponent.successMsg("批量审批提交成功!");
                    this.framePager.reload();
                      
                   
             });
        });

        
    }

    async doVerifyAll(){
       let repParam =  _.cloneDeep(this.query);
       repParam['fromStatus'] = APPLY_STATUS.PROV_VERIFY;
       repParam['toStatus'] = APPLY_STATUS.LOCAL_VERIFY;
        FrameRequest.requestMap(this.VERIFY_ALL_URL, 
            repParam, async (map) => {
                this.hideModal();
                //AppComponent.alert({title:"信息提示",text:"全部审批通过提交成功!"});
                AppComponent.GobalComponent.successMsg("全部审批通过提交成功!");
                this.framePager.reload();
         });

    }
    
    downloadTemplate() {
        FrameRequest.download('/std/stdRegInfo/downloadTpl.htm', {fileName: 'mk_apply.doc'});
    }
  
    downApplyPDF(){
        let checkArray = this.framePager.getCheckedArray();
  
        if(checkArray.length != 1){
          AppComponent.alert({title:"信息提示",text:"请单选一条申请数据!"});
          return
        }
        FrameRequest.download('mk/mkCertEduApply/downApplyPDF.htm', {std_id:checkArray[0].std_reg_id,time_config_id:checkArray[0].time_config_id,status:2});
    }

    isPakage(path){
        if(path.indexOf('zip') != -1 || path.indexOf('rar') != -1){
            return true;
        }
        return false;
    }

    changeRemark(remark){
        this.item.verify2_remark=remark;
    }

    callBack(){
        let checkedArray =  this.framePager.getCheckedArray();
        if(checkedArray.length == 0 ||checkedArray.length>1){
            AppComponent.alert({title:"信息提示",text:"请选择一条数据!"});
            return;
        }
    
        AppComponent.confirm("确定撤回吗?",()=>{
            FrameRequest.request("mk/mkCertEduApply/callBack.htm", {apply_id:checkedArray[0].id}, async ()=>{
                //刷新
                this.framePager.reload();
                AppComponent.GobalComponent.successMsg("撤回成功!");
            
            });
        });
    
      }

      
  
showImg(editFormTemplateModal,path) {
    this.file_path = path;
    this.curr_id = path;
    this.current =0;
   
    let css = "modal-bg";
    this.bsModalWin2 = this.bsModalService.show(editFormTemplateModal, { class: css });
  
  }
  
  rotate(i){
  
    var imge = document.getElementById(this.curr_id);
    if(i ==0){
      this.current = (this.current-90)%360
    }else if(i ==1){
      this.current = (this.current+90)%360
    }
  
    
  
  imge.style.transform='rotate('+this.current+'deg)';
  
  if(imge.offsetWidth>imge.offsetHeight){
    imge.style.marginTop = (imge.offsetWidth-imge.offsetHeight)/2+"px";
  
  }
    
  }
}


